﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApp1//作者:小星星 QQ:2651016568 QQEmily:2651016568@qq.com
{
    public partial class Form1 : Form
    {
        private string extension;
        private string path;
        private string paths = "D:\\转译文件";
        private string currentMp3 = "";
        public Form1()
        {
            InitializeComponent();
            this.linkLabel1.Click += LinkLabel1_Click;
        }

        private void LinkLabel1_Click(object sender, EventArgs e)
        {
            Process.Start(this.currentMp3);
        }

        private void Form1_DragEnter(object sender, DragEventArgs e)
        {
            e.Effect = DragDropEffects.All;//设置拖动操作
        }
        private void TextBox1_TextChanged(object sender, EventArgs e)
        {
            paths = textBox1.Text;//输入保存路径给paths
        }

        private void DecodeKgtemp(string tempFile)
        {
            if (!File.Exists(tempFile))
            {
                return;
            }
            var extension = Path.GetExtension(path);
            if (string.Equals(extension, ".kgtemp", StringComparison.CurrentCultureIgnoreCase))
            {
                byte[] key = { 0xAC, 0xEC, 0xDF, 0x57 };
                using (var input = new FileStream(tempFile, FileMode.Open, FileAccess.Read))
                {
                    var tempFileName = path.Substring(path.LastIndexOf("\\") + 1);
                    //获取路径中的文件名（带后缀的） ，fz的值为 “----.kgtemp”
                    string cleanName = System.Text.RegularExpressions.Regex.Replace(tempFileName, "[.kgtemp]", "");//去掉.kgtemp后缀名后赋值给fss
                    if (!Directory.Exists(paths))
                    {
                        Directory.CreateDirectory(paths);//创建目录
                    }
                    var output = File.OpenWrite(paths + "\\" + cleanName + ".mp3");//输出文件
                    currentMp3 = paths + "\\" + cleanName + ".mp3";
                    input.Seek(1024, SeekOrigin.Begin);//跳过1024字节的包头
                    byte[] buffer = new byte[key.Length];
                    int length;
                    while ((length = input.Read(buffer, 0, buffer.Length)) > 0)
                    {
                        for (int i = 0; i < length; i++)
                        {
                            var k = key[i];
                            var kh = k >> 4;
                            var kl = k & 0xf;
                            var b = buffer[i];
                            var low = b & 0xf ^ kl;//解密后的低4位
                            var high = (b >> 4) ^ kh ^ low & 0xf;//解密后的高4位
                            buffer[i] = (byte)(high << 4 | low);
                        }
                        output.Write(buffer, 0, length);
                    }
                    output.Close();
                }

            }
        }


        private void Form1_DragDrop(object sender, DragEventArgs e)
        {
            path = (((System.Array)e.Data.GetData(DataFormats.FileDrop)).GetValue(0).ToString());//获取拖动的文件路径
            extension = Path.GetExtension(path);//获取指定路径的文件扩展名
            if (Directory.Exists(path))//如果是文件夹
            {
                DirectoryInfo dinfo = new DirectoryInfo(path);//实例化一个DirectoryInfo对象
                foreach (FileSystemInfo f in dinfo.GetDirectories())//获取子目录
                {
                    if (f is DirectoryInfo)//如果是文件夹
                    {
                        MessageBox.Show(f.Name + "  程序仅读取一级目录，子目录下的文件无能为力。");//显示子目录名称
                    }
                }
                int success = 0;
                foreach (FileInfo fs in dinfo.GetFiles("*.kgtemp")) //查找.kgtemp文件
                {
                    byte[] key = { 0xAC, 0xEC, 0xDF, 0x57 };
                    using (var input = new FileStream(path + '\\' + fs.Name, FileMode.Open, FileAccess.Read))//kgtemp文件的完整路径,两条斜杠是为了避免转义字符
                    {
                        string fss = System.Text.RegularExpressions.Regex.Replace(fs.Name, "[.kgtemp]", "");//去掉.kgtemp后缀名后赋值给fss
                        if (!Directory.Exists(paths))//如果没有该目录,    如果电脑没有G盘修改这里和输出文件那一行,改变保存路径
                        {
                            Directory.CreateDirectory(paths);//创建目录
                        }
                        var output = File.OpenWrite(paths + "\\" + fss + ".mp3");//输出文件:目录+去掉后缀名的文件名+.MP3后缀名
                        currentMp3 = paths + "\\" + fss + ".mp3";
                        input.Seek(1024, SeekOrigin.Begin);//开始读取kgtemp文件,先跳过1024字节包头
                        byte[] buffer = new byte[key.Length];
                        int length;
                        while ((length = input.Read(buffer, 0, buffer.Length)) > 0)
                        {
                            for (int i = 0; i < length; i++)
                            {
                                var k = key[i];
                                var kh = k >> 4;
                                var kl = k & 0xf;
                                var b = buffer[i];
                                var low = b & 0xf ^ kl;//解密后的低4位
                                var high = (b >> 4) ^ kh ^ low & 0xf;//解密后的高4位
                                buffer[i] = (byte)(high << 4 | low);
                            }
                            output.Write(buffer, 0, length);//转译方面代码来源:http://www.cnblogs.com/KMBlog/p/6877752.html 作者:孤心浪子
                        }
                        output.Close();

                    }
                    var mp3 = ID3Helper.ReadMp3(currentMp3);

                    string filename = mp3.Title + "-" + mp3.Artist + ".mp3";
                    //去除非法字符
                    StringBuilder rBuilder = new StringBuilder(filename);
                    foreach (char rInvalidChar in Path.GetInvalidFileNameChars())
                        rBuilder.Replace(rInvalidChar.ToString(), string.Empty);
                    string realFileName = paths + "\\" + rBuilder.ToString();
                    if (File.Exists(realFileName))
                    {
                        File.Delete(realFileName);
                    }
                    File.Move(currentMp3, realFileName);                    
                    success++;
                }
                MessageBox.Show("转换完成了" + success + "个文件");
            }
            else
            {
                if (string.Equals(extension, ".kgtemp", StringComparison.CurrentCultureIgnoreCase))//如果后缀名是.kgtemp(不区分大小写的)
                {
                    byte[] key = { 0xAC, 0xEC, 0xDF, 0x57 };
                    using (var input = new FileStream(path, FileMode.Open, FileAccess.Read))
                    {
                        string fz = path.Substring(path.LastIndexOf("\\") + 1);
                        //获取路径中的文件名（带后缀的） ，fz的值为 “----.kgtemp”
                        string fss = System.Text.RegularExpressions.Regex.Replace(fz, "[.kgtemp]", "");//去掉.kgtemp后缀名后赋值给fss
                        if (!Directory.Exists(paths))//如果没有该目录,    如果电脑没有G盘修改这里和输出文件那一行,改变保存路径
                        {
                            Directory.CreateDirectory(paths);//创建目录
                        }
                        var output = File.OpenWrite(paths + "\\" + fss + ".mp3");//输出文件
                        currentMp3 = paths + "\\" + fss + ".mp3";
                        input.Seek(1024, SeekOrigin.Begin);//跳过1024字节的包头
                        byte[] buffer = new byte[key.Length];
                        int length;
                        while ((length = input.Read(buffer, 0, buffer.Length)) > 0)
                        {
                            for (int i = 0; i < length; i++)
                            {
                                var k = key[i];
                                var kh = k >> 4;
                                var kl = k & 0xf;
                                var b = buffer[i];
                                var low = b & 0xf ^ kl;//解密后的低4位
                                var high = (b >> 4) ^ kh ^ low & 0xf;//解密后的高4位
                                buffer[i] = (byte)(high << 4 | low);
                            }
                            output.Write(buffer, 0, length);
                        }
                        output.Close();
                    }

                    var mp3 = ID3Helper.ReadMp3(currentMp3);

                    string filename = mp3.Title + "-" + mp3.Artist + ".mp3";                    
                    //去除非法字符
                    StringBuilder rBuilder = new StringBuilder(filename);
                    foreach (char rInvalidChar in Path.GetInvalidFileNameChars())
                        rBuilder.Replace(rInvalidChar.ToString(), string.Empty);
                    string realFileName = paths + "\\" +rBuilder.ToString();
                    if (File.Exists(realFileName))
                    {
                        File.Delete(realFileName);
                    }
                    File.Move(currentMp3, realFileName);
                    currentMp3 = realFileName;
                    linkLabel1.Text = "转换完成,点击播放" + currentMp3;
                }
                else
                {
                    MessageBox.Show(extension, "无效后缀名");
                }
            }
        }

        private void label2_Click(object sender, EventArgs e)
        {

        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (folderBrowserDialog1.ShowDialog() == DialogResult.OK)
            {
                this.textBox1.Text = folderBrowserDialog1.SelectedPath;
                paths = textBox1.Text;
            }
        }
    }
}

